@echo on
REM -----------------------------------------------------
REM
REM Sichert PostgreSQL Datenbanken eines Server
REM
REM
REM Unterhalb dieser Datei muss ein Ordner WEEK und oder DAYLY
REM vorhanden sein. Entspricht den beiden mglichen Aufrufparametern
REM 
REM In jedem Ordner muss eine Datei vorhanden sein, welche
REM pro Zeile den Namen der zu sichernden Datenbank enthlt
REM
REM Der Dateiname lautet immer dblist.txt
REM Optional
REM kann eine Datei "dbName".schemas.txt vorhanden sein.
REM Ist dies der Fall, wird nicht die ganze Datenbank gesichert, 
REM sondern nur die in der Datei (ein Eintrag pro Zeile)
REM angegebenen Schemata.
REM 
REM Die Sicherung einer gesamten Datenbank erfolgt im Binrformat.
REM Die Sicherung eines Schemas als SQL mit der Option "Drop".
REM
REM Anzupassen sind:
REM -----------------------------------------------------
REM pgpassword
REM pgConnect
REM targetBase
REM -----------------------------------------------------
REM Der Pfad mu angepasst werden
set pg_dump=C:\Programme\PostgreSQL\8.2\bin\pg_dump.exe
set chronMode=%1
set targetBase=%2
set pgpassword=%3
REM Netzwerkadresse, Port, und Benutzer anpassen 
set pgConnect=-h localhost -p 5432 -U postgres
set currentPath=%~dp0

call :checkArguments
if "%currentPath%" NEQ "" if exist "%currentPath%\dblist.txt" for /f "Delims=" %%I in (%currentPath%\dblist.txt) DO call :SaveDatabase %%~I

goto :eof
rem ----------------------
rem Prft die Argumente
rem ----------------------
:checkArguments
	if "%targetBase%" EQU "" goto :usage
	if /I "%chronMode%" EQU "WEEK" goto :checkDirs
	if /I "%chronMode%" EQU "DAYLY" goto :checkDirs
	:usage
	echo Fehler: makePgdumps {WEEK or DAYLY} {ZielPfad} {RootPassword}
	pause	
	set currentPath=
	goto :eof
:checkDirs	
	set currentPath=%currentPath%\%chronMode%

goto :eof
rem ----------------------
:SaveDatabase
rem ----------------------
	set schemaFile=%currentPath%\%1.schemas.txt
	if exist "%schemaFile%" call :_saveSchema %1 %schemaFile%
	if not exist "%schemaFile%" call :_saveDB %1
goto :EOF

REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM Sichert einzelne Schemata
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
:_saveSchema
	set targetFolder=%targetBase%\%chronMode%
	if not exist %targetFolder% mkdir %targetFolder%
	for /f "Delims=" %%I in (%2) DO call :_saveOneSchema %1 %%~I
goto :EOF
:_saveOneSchema
	set targetFile=%targetFolder%\%1.%2.sql	
	echo Backup des Schemas %2 der Datenbank %1
	%pg_dump% -i %pgConnect% -F p -c -v -f %targetFile% -n %2 %1	
goto :EOF
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM Sichert die gesamte Datenbank
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
:_saveDB
	echo Backup der gesamten Datenbank %1
	set targetFolder=%targetBase%\%chronMode%
	if not exist %targetFolder% mkdir %targetFolder%
	set targetFile=%targetFolder%\%1.backup	
	%pg_dump% -i %pgConnect% -F c -b -v -f %targetFile% %1
goto :EOF
